/******************************
  MODULO DE BLOB ~
*******************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/******************************
 Definicin de tipos de datos.
*******************************/

typedef unsigned char CHAR; 

typedef CHAR *LPSTR,*LPCH; 

typedef unsigned char BYTE; 
typedef unsigned short WORD;
 
typedef BYTE *LPBYTE; 


typedef int BOOL;
typedef BOOL *LPBOOL;

 
/*******************************************
   VARIABLES GLOBALES , LOCALES AL MODULO */


/* Definen el tamao X,Y, nmero de canalaes 
	y bytes por pixel de la imagen de entrada */
WORD wXSize=0;
WORD wYSize=0;
WORD wChanels=1;
WORD wPixelSize=1;


/* Array de bytes con los datos de la imagen
	de entrada, organizada por filas	*/
LPBYTE data;

/* Nombre del archivo de entrada */
char entrada1[40];

/* Nombre del archivo de salida */
char salida1[40];

/* Path donde ubicar los archivos */
char path[140];

/* Nombre completo del archivo de entrada */
char completoentrada1[180];

/* Nombre completo del archivo de salida */
char completosalida1[180];
	
/* Parmetro que indica el mnimo nmero de 
	pixeles que debe tener un blob para ser
	considerado como tal y no como ruido */
int vpixel=10;

/* Nmero mximo de blobs que se admite
	calcular, si la imagen posee ms de esta
	cantidad de blobs el programa debe
	devolver un error */
int vblob=100;

/* Array donde se guardan los valores de 
	la coordenda X del centro de masas
	de cada blob */
unsigned long int	*wCoordX;

/* Array donde se guardan los valores de 
	la coordenda Y del centro de masas
	de cada blob */
unsigned long int	*wCoordY;

/* Array donde se guardan los valores del 
	eje principal de cada uno de los 
	blobs */
float	*wEjes;

/* Nmero de blobs existentes en la imagen */
unsigned long int	wNumBlobs;

/* Tamao total de datos en el archivo de entrada */
unsigned long int capacidad;

/******************************************/
/******************************************/

/* FUNCIONES */

 void Reordenar(int pos_i, int pos_j, BYTE **MA, int num_abajo, int num_arriba) {
 		
 		//Permite la renumeracion de los blobs en el caso que sea necesario
 		 
     	int i,j;
    	bool salir=false;

    	if(num_abajo>num_arriba){					
    	
									//Si numblob abajo es mayor a numblob arriba
    		
    		MA[pos_i][pos_j]=num_arriba;		
    										//El valor de la matriz[pos_i][pos_j]=numblob arriba
    		
    		for(i=0;(i<(int)wYSize)&&(!salir);i++){
    										//buscamos para reordenar hasta donde llevemos introducida de matriz de imagen
    			
    			for(j=0;(j<(int)wXSize)&&(!salir);j++){
    			
    				
    				if(i==pos_i && j==pos_j){		//Debemos saber hasta donde debemos comprobar 
	  						salir=true;				//Salir=true indica hemos llegado al fin de matriz de copia
					}    				
    												
											//Si no he llegado al final de matriz de copia entonces     										
    				else{
    					if(MA[i][j]==num_abajo){		
    						MA[i][j]=num_arriba;
    										//Si un pixel es de numblob abajo lo cambio al numblob arriba 
    					}
    							
    					if(MA[i][j]>num_abajo){	
    						MA[i][j]=MA[i][j]-1;
											//Si un pixel es mayor a numblob abajo le resto 1 para renumerar sin saltos 			
						}
    				}
    				
     			}//for
    		}//for
    	}//if
    
    
    	if(num_arriba>num_abajo){						
    										//Si numblob arriba es mayor a numblob abajo
    		
    		MA[pos_i][pos_j]=num_abajo;			
    										//El valor de la matriz[pos_i][pos_j]=numblob abajo
    		
    		for(i=0;(i<(int)wYSize)&&(!salir);i++){
    										//buscamos para reordenar hasta donde llevemos introducida de matriz de imagen
    										
    			for(j=0;(j<(int)wXSize)&&(!salir);j++){
    			
    										
    				
    				if(i==pos_i && j==pos_j){		//Debemos saber hasta donde debemos comprobar	
    						salir=true;				//Salir=true indica hemos llegado al fin de matriz de copia
    				}
    										//Si no he llegado al fin de matriz de copia
    				
    				else{
    				
						if(MA[i][j]==num_arriba){		
    						MA[i][j]=num_abajo;
    										//Si un pixel es de num_blob arriba lo cambio al num_blob abajo
    					}
   							
    					if(MA[i][j]>num_arriba){
    						MA[i][j]=MA[i][j]-1;
    										//Si un pixel es mayor a num_blob arriba le resto 1 para renumerar sin saltos
    					}
					}
    				
    			}//for
    		}//for
    	}//else

	}//funcion


            /***********CENTRO DE GRAVEDAD_X****************/
 //funcion que calcula el centro de gravedad Cx de un objeto

 unsigned long int Centro_GravedadX(BYTE **MA, int n_blob){
  int y,x;
  int cont_x=0;
  int cont_puntos=0;
 
  //suma de todos los puntos x de un blob dividido por el numero total de puntos.

  for(y=0; y<(int)wYSize; y++){
          for(x=0; x<(int)wXSize; x++){

                   if(MA[y][x]==n_blob){
                           cont_x+=x;
                           cont_puntos++;
                   }
          }//del for

  }//del for

  // *** Para evitar divisin por cero
  if (cont_puntos==0)
	  return 0;

  return cont_x/cont_puntos;
 }

             /***********CENTRO DE GRAVEDAD_Y****************/
  //funcion que calcula el centro de gravedad Cy de un objeto

 unsigned long int Centro_GravedadY(BYTE **MA, int n_blob){
  int y,x;
  int cont_y=0;
  int cont_puntos=0;
 
  //suma de todos los puntos y de un blob dividido por el numero total de puntos.
  for(y=0; y<(int)wYSize; y++){
          for(x=0; x<(int)wXSize; x++){

                   if(MA[y][x]==n_blob){
                           cont_y += y;
                           cont_puntos++;
                   }
          }//del for

  }//del for

  // *** Para evitar divisin por cero
  if (cont_puntos==0)
	  return 0;

  return cont_y/cont_puntos;
 }

              /***********CALCULAR MOMENTOpq*************/

  //funcion que calcula el momento de orden pq para un objeto determinado

  double Momento(int p, int q, int blob, BYTE **Matriz ){
  int y,x;
  double sum=0;
  //Para referencia a Cx y Cy correspondiente al blob debo mirar wCoord[blob-1]
  //pues para el blob i su Cx o Cy se guarda en xWCoord[blob-1], yWCoord[blob-1] respectivamente
 
  for(y=0; y<(int)wYSize; y++){
          for(x=0; x<(int)wXSize; x++){
                if(Matriz[y][x]==blob){
                       sum=sum+( pow((double)x-wCoordX[blob-1] ,p) * pow((double)y-wCoordY[blob-1] ,q) );
                }
          }//del for

  }//del for
  //printf("En MOMENTO --momento %d%d  %f\n",p,q,sum);
  return sum;
}

             /***********CALCULAR ANGULO DEL EJE*************/
 //funcion que calcula el angulo del eje principal de cada uno de los objetos

 float AnguloEjes(BYTE **MA, int n_blob){

  double angulo;
  double radianes;

  //El resultado proporcionado por atan2 es en radianes

  radianes=-0.5*atan2( 2*Momento(1,1,n_blob, MA),Momento(2,0,n_blob, MA)- Momento(0,2,n_blob, MA)  );

  //Pasamos a grados los radianes obtenidos

  angulo= 180*radianes/3.14159;

  return (float)angulo;
}


// *** Elimina blobs con menos vpixel pixels. Renumera los blobs y
// devuelve el nuevo numero de blobs
int  EliminarBlobs(int num_blobs, BYTE** salida)
{
	int y,x,b,xr,yr;
	int cuenta;

	for(b=1; b<=num_blobs; b++) // el valor b=0 es para identificar lo que no es blob
	{
		cuenta=0;
		for(y=0; y<(int)wYSize; y++)
			for(x=0; x<(int)wXSize; x++)
				if(salida[y][x]==b)
					cuenta++;

		// Si hay que eliminar el blob
		if (cuenta <(int)vpixel)
		{
			// Se decrementan los indices de blobs para quitar el actual
			for(yr=0; yr<(int)wYSize; yr++)
				for(xr=0; xr<(int)wXSize; xr++)
					// Borra blobs actual
					if(salida[yr][xr]==b)
						salida[yr][xr]=0;
					// Decrementa indices del los blobs por encima del actual
					else if(salida[yr][xr]>b)
						salida[yr][xr]--;
			
			// Hay un blob menos
			num_blobs--;
			// Y hay que mirar de nuevo el actual
			b--;
		}
	}

	return num_blobs;
}

/******************************************/
/******************************************/
/* Esta es la funcin que calcula los blobs
	es la que debe ser modificada por el
	alumno para incluir el clculo de blobs */
/******************************************/
int calcularBlob()
{
 int i,j,opcion;
 int i_data=-1;
 int num_blob=0;		//Me indica el numero de blob por el que voy Al finalizar indicara el numero total de blobs
 int blob_fondo=0;	//El blob de fondo es negro
 int wXSize1,wYSize1;    // Limites de la imagen

 wYSize1 = (int)wYSize+1;
 wXSize1 = (int)wXSize+1;

  /*******************RESERVA DE MEMORIA PARA LAS MARTICES********************/

 BYTE **M_entrada=new BYTE* [wYSize1];  //ponemos una fila mas pq necesito el borde de puntos negro
 
 // *** Si hubo problemas...
 if(M_entrada==NULL)
 {
	printf("\nError al reservar memoria para procesar imagen");
	return 10;
 }

 BYTE **M_salida=new BYTE* [wYSize];

 // *** Si hubo problemas...
 if(M_salida==NULL)
 {
	delete M_entrada;
	printf("\nError al reservar memoria para procesar imagen");
	return 10;
 }

 for(i=0; i<wYSize1;i++)
 {
     M_entrada[i]=new BYTE [wXSize1];//ponemos una fila mas pq necesito el borde de puntos negro

	 // *** Si hubo problemas...
	 if (M_entrada[i]==NULL)
	 {
		 for(j=0; j<i;i++)
			 delete M_entrada[j];

		 delete M_entrada;
		 delete M_salida;
		 printf("\nError al reservar memoria para procesar imagen");
		 return 10;
	 }
 }

 for(i=0; i<(int)wYSize;i++)
 {
     M_salida[i]=new BYTE [wXSize];

	 // *** Si hubo problemas...
	 if (M_salida[i]==NULL)
	 {
		 for(j=0; j<i;i++)
			 delete M_salida[j];

		 for(j=0; j<wYSize1;j++)
			 delete M_entrada[j];

		 delete M_entrada;
		 delete M_salida;
		 printf("\nError al reservar memoria para procesar imagen");
		 return 10;
	 }
 }


/************************RELLENO MATRIZ DE ENTRADA**********************/

//RELLENO EL BORDE DE PIXEL NEGRO DE COLOR DE FONDO

  //Las columnas
 for(j=0;j<wXSize1;j++)
	M_entrada[0][j]=0;

 //Las filas
 for(i=0;i<wYSize1;i++)
     M_entrada[i][0]=0;

						
//RELLENO RESTO MATRIZ CON PIXELES DE IMAGEN ORIGINAL

//Si el elemento i del vector data es un 255 pondre 1 en mi matriz de entrada
//Si el elemento i del vector data es un 0   pondre 0 en mi matriz de entrada

 i_data=0;
 for(i=1;i<wYSize1;i++){
     for(j=1;j<wXSize1;j++){
            //Debemos tener en cuenta que la imagen se ha umbralizado y posee el marco

            /*if(data[i_data]==0)
            	M_entrada[i][j]=0;
            if(data[i_data]==255)
                M_entrada[i][j]=1;*/

			M_entrada[i][j]=(data[i_data++]==255)?1:0;

     }//FOR
 }//FOR



//**********************PROCEDIMIENTO*******************
//Se aplica los casos a todos los pixeles de la imagen original + marco


	for(i=1;i<wYSize1;i++){
		for(j=1;j<wXSize1;j++){
					
			if ((i==188+1) && (j==178+1))
				i=i;

                    opcion=M_entrada[i][j]+2*M_entrada[i-1][j]+4*M_entrada[i-1][j-1]+8*M_entrada[i][j-1];
					//Se trata de la mascara y me permite saber a que caso pertenece cada iteracion
					
					switch(opcion){
					
						//La matriz auxiliar la referenciamos con un indice menos
					
						//Conectar a blob de fondo
						case 0:
						case 2:
						case 4://fin blob objeto conectar a blob de fondo-> sin problema pues solo 1 blob de fondo
						case 6:
						case 8:			
						case 10:			
						case 12:M_salida[i-1][j-1]=blob_fondo;break;

						case 14:M_salida[i-1][j-1]=blob_fondo;break;
					
						//Comenzar nuevo blob
						case 1:num_blob++; M_salida[i-1][j-1]=num_blob;break;

                        //Hay 8-conexion Conectar a blob de objeto
						case 5: M_salida[i-2][j-2]=num_blob;break;
												
						//Conectar a blob objeto			
						case 3:
						case 7:M_salida[i-1][j-1]=M_salida[i-2][j-1];break;
						
						//Conectar a blob objeto
						case 9:			
						case 13:			
						case 15:M_salida[i-1][j-1]=M_salida[i-1][j-2];break;
												
						//Caso particular. Se unen 2 franjas
						case 11:
								//Caso las 2 franjas son de != blob
								if(M_salida[i-1][j-2]!=M_salida[i-2][j-1]){
									Reordenar(i-1,j-1,M_salida,M_salida[i-1][j-2],M_salida[i-2][j-1]);
									num_blob--;
								
									//He restado a todos un blob tengo asi un blob menos
									//i-1	    ***Para saber hasta que fila tengo introducida la imagen en la M_salida
									//j-1	    ***Para saber hasta que columna tengo introducida la imagen en la M_salida
									//M_salida	***Para poder renombrar los blobs de la matriz
									//M_salida[i-1][j-2]	***Indica el numblob del Pixel inferior
									//M_salida[i-2][j-1]	***Indica el numblob del Pixel superior
								}
								
								//Caso las 2 franjas son del mismo blob
								else{
									
									if(M_salida[i-1][j-2]==M_salida[i-2][j-1]){
										M_salida[i-1][j-1]=M_salida[i-1][j-2];
										//Da lo mismo igualar al de arriba o al de abajo	
									}							
								}
								break;

						
					}//del switch
				
				}//del for
			
			}//del for


  // *** Eliminar blobs con pocos pixeles
  num_blob = EliminarBlobs(num_blob, M_salida);

  // *** Limita el numero de blobs a calcular
  if (num_blob>vblob)
	  num_blob=vblob;

  //Empezamos en blob 1 pues 0 es el blob de fondo

  //Para todos los objetos Calcularemos su:
  //+Centro de masas Cx
  //+Centro de masas Cy
  //+Angulo de inclinacion del eje principal

  for(i=1;i<=num_blob; i++){

          wCoordX[i-1]=Centro_GravedadX(M_salida,i);
          wCoordY[i-1]=Centro_GravedadY(M_salida,i);
          wEjes[i-1]=AnguloEjes(M_salida,i);
  }//del for


 //Asignar el total de blobs a la variable global que contea los blobs
 wNumBlobs=num_blob;
 return 0;

}
/******************************************/
/******************************************/
/******************************************/


/* Esta funcin lee la imagen de entrada
	y prepara los arrays de datos para
	el clculo de los blobs */
int previoBlob()
{
	/* Variable que sirve de contador en los bucles */
	unsigned long int d=0;

	/* Variable para guardar el cdigo de error 
		a devolver en caso de error por la
		llamada a la funcin de calcularBlob */
	int result;

	/* Variables que indican el tamao en X, Y, 
		nmero de canales y bytes por pixel de la
		imagen de salida (esta imagen en realidad
		contiene la informacin de los centros
		de masa de cada blob */
	WORD	xSize, ySize;
	WORD	chanels, pixelSize;

	/* Variables de archivo para el de entrada (p) y
		el de salida (sal) */
	FILE *p,*sal;

	/* Reserva de memoria para el array de coordenadas X */
	if( (wCoordX = new unsigned long int [vblob])==NULL )
	{
		printf("\nError al reservar memoria");
		return 1;
	}
	/* Reserva de memoria para el array de coordenadas Y */
	if( (wCoordY = new unsigned long int [vblob])==NULL )
	{
		printf("\nError al reservar memoria");
		return 2;
	}
	
	/* Reserva de memoria para el array de ejes principales */
	if( (wEjes = new float [vblob])==NULL )
	{
		printf("\nError al reservar memoria");
		return 3;
	}

	/* Apertura del fichero de entrada */
    if((p=fopen(completoentrada1,"rb"))==NULL)
	{
		printf("\nError al abrir el archivo");
		return 4;
	};

	/* Lectura de los parmetros del fichero de entrada */
	fread(&wXSize,sizeof(wXSize),1,p);
	fread(&wYSize,sizeof(wYSize),1,p);
	fread(&wChanels,sizeof(wChanels),1,p);
	fread(&wPixelSize,sizeof(wPixelSize),1,p);
	
	/* Clculo de la cantidad de datos en la imagen
		original */ 
	capacidad=wXSize*wYSize*wChanels*wPixelSize;

	/* Reserva de memoria para los datos de la imagen */
	if( (data=::new BYTE[capacidad])==NULL )
	{
		printf("\nError al reservar memoria");
		return 5;
	}

	/* Lee los datos de la imagen de entrada */
	if(fread(&data[d],sizeof(data[d]),capacidad,p)!=capacidad)
	{
		printf("\nError de archivo");
		return 6;
	}

	/* Cierra el archivo origen de los datos */
	fclose(p);

	/* LLama a la funcin implementada por el alumno
		para calcular los blobs */

	if( (result=calcularBlob())!=0 )
	{
		printf("\nError al calcular el Blob");
		return result;
	}


	/* Abre el fichero de salida para almacenar
		los resultados obtenidos */ 
	if((sal=fopen(completosalida1,"wb"))==NULL)
	{
		printf("\nError al crear el archivo");
		return 7;
	};



	/* Asigna los valores del tamao del archivo 
		destino necesarios para que correspondan
		con los de una imagen en los que los datos
		sern los centros de masa de los distintos
		blobs y sus ejes.*/

	// Para que sea compatible con una imagen float
	xSize = (WORD) ((wNumBlobs*3+1));
	ySize = 1;
	chanels = 1; 
	pixelSize = sizeof(float);
	fwrite(&xSize,sizeof(xSize),1,sal);
	fwrite(&ySize,sizeof(ySize),1,sal);
	fwrite(&chanels,sizeof(chanels),1,sal);
	fwrite(&pixelSize,sizeof(pixelSize),1,sal);
	
	/* Guarda el nmero de blobs en el archivo */
	float valFlo[3];
	valFlo[0] = (float)wNumBlobs;
	fwrite(&valFlo[0],sizeof(float),1,sal);

	/* Gruada para cada blob su coordenada X y 
		su coordenada Y */
	for(d=0;d<wNumBlobs;d++)
	{
		valFlo[0] = (float)wCoordX[d];  // pos X
		valFlo[1] = (float)wCoordY[d];  // pos X
		valFlo[2] = wEjes[d];		 // grados

		if(fwrite(valFlo,3*sizeof(float),1,sal)!=1)
		{
			printf("\nError de archivo");
			return 8;
		}
	}


	/* Cierra el archivo de resultados */
	fclose(sal);
	
	/* Devuelve que todo ha ido correctamente */
	return 0;
}




/* Funcin auxiliar para escribir los nombres de
	los archivos correctamente del formato que da
	el programa a nombres estandard */

void quitarasterisco()
{
	/* Variables contador */
	unsigned int i,j=0;
	/* Cadena auxiliar */
	char auxiliar[140];

	/* Cambia los '*' por espacios */
	for(i=0,j=0;i<strlen(path);++i,++j)
	{
		if(path[i]=='*') auxiliar[j]=' ';
		else auxiliar[j]=path[i];
	}
	auxiliar[j]='\0';
	

	/* Aade al nombre del archivo origen
		el path */
	strcpy(completoentrada1,auxiliar);
	strcat(completoentrada1,entrada1);

	/* Aade al nombre del archivo destino
		el path */
	strcpy(completosalida1,auxiliar);
	strcat(completosalida1,salida1);
}


/* Funcin principal del programa. Tiene
	los siguiente argumentos importantes:
		argv[0] => Nombre del ejecutable del modulo
		argv[1] => Funcin que debe hacer el modulo (debe ser 0)
		argv[2] => Numero de entradas que recibe el modulo (debe se 1)
		argv[3] => Numero de salidas que tiene el modulo (debe se 1)
		argv[4] => Path donde tratar con los archivos temporales.
		argv[5] => Nmero mnimo de pixeles que ha de contener
					un blob para considerarlo como tal.
		argv[6] => Nmero mximo de blobs que se admiten que tenga
					la imagen. Si tiene ms debe delverse un cdigo
					de error.
		argv[7] => Nombre del archivo temporal de entrada
		argv[8] => Nombre del archivo temporal de salida
   Esta funcin devuelve 0 si todo ha funcionado correctamente,
   y un valor mayor que 0 si ha habido algn error.
*/
int main(int argc, char* argv[])
{
	/* Variable que contiene el cdigo error
		a devolver */
	int result = 0;

	// Requiere una imagen de entrada, un parmetro y una salida
	if (argc<8)
		return 20;

	int iNum = atoi(argv[2]);
	if (iNum != 1)
		return 20;
	
	iNum = atoi(argv[3]);
	if (iNum != 1)
		return 20;

	// lectura de parmetros
	strcpy(path,argv[4]);
	vpixel=atoi(argv[5]);
	vblob=atoi(argv[6]);

	strcpy(entrada1,argv[7]);
	strcpy(salida1,argv[8]);
	/* Ajuste de los nombres de los archivos */
	quitarasterisco();


	/* Calcula los Blobs */
    result = previoBlob();

	/* Libera la memoria de las variales globales
		que tienen memoria reservada */
	delete data;
	delete wCoordX;
	delete wCoordY;
	delete wEjes;

	/* Devuelve el cdigo de error correspondiente */
	return result;
}
